* SQLBROW.PRG
* (c) Copyright 1990-1991 Brad H. Codd, All rights reserved
*
* To order CLIPSQL or for more information contact:
*    Brad H. Codd
*    Unisoft Marketing
*    P O Box 23070
*    Joubert Park, 2044
*    South Africa
*    (011) 642-4588 Work
*    (011) 623-1683 Home
*    (011) 484-2923 Fax

#include "inkey.ch"

? "Clipper 5.01 SQL Server/Sybase Table Browser, Version 1.00"
? "(c) Copyright 1990-1991 Brad H. Codd, All rights reserved"
?
? "Press any key to start..."
INKEY(0)
?
?
sqlSERVER = 'ALADDIN'
sqlUSER = 'SA'
sqlPASSWORD = ''
DO logon WITH sqlSERVER, sqlUSER, sqlPASSWORD

Browser()
Return

Procedure Browser

Local aRowList
Local aColList
Local sqlCOLUMNS
Local oBrowse
Local nTop := 1
Local nLeft := 0
Local nBottom := MaxRow() - 2
Local nRight := MaxCol() - 2
Local nRow := 1
Local nKey

Cls

sqlLOGIN(sqlSERVER, sqlUSER, sqlPASSWORD)       && Login
sqlUSE("pubs")                                  && Database
sqlQUERY("SELECT au_id, au_lname FROM authors") && SQL Query
sqlRESULTS()                                    && Bind Results
aRowList := {}
DO WHILE .T.
   sqlCOLUMNS = sqlNEXTROW()                    && Fetch Next Row
   IF sqlCOLUMNS > 0
      aColList := {}
      FOR sqlCOLUMN = 1 TO sqlCOLUMNS
         AAdd(aColList, sqlNEXTCOL())           && Fetch Next Column
      NEXT
      AAdd(aRowList, aColList)
   ELSE
      EXIT
   ENDIF
ENDDO
sqlLOGOUT()                                     && Logout

oBrowse               := TBrowseNew( nTop, nLeft, nBottom, nRight )
oBrowse:HeadSep       := ""
oBrowse:ColSep        := "  "
oBrowse:GoTopBlock    := {|| nRow := 1}
oBrowse:GoBottomBlock := {|| nRow := Len( aRowList )}
oBrowse:SkipBlock     := {|nRowMove| SkipArray(nRowMove, Len( aRowList ), @nRow)}

oColumn       := TBColumnNew( "Author Id", {|| aRowList[nRow, 1]} )
oColumn:Width := 11
oBrowse:addColumn( oColumn )

oColumn       := TBColumnNew( "Last Name", {|| aRowList[nRow, 2]} )
oColumn:Width := 40
oBrowse:addColumn( oColumn )

Do While .T.

   Do While !(oBrowse:Stabilize()) .And. ((nKey := Inkey()) == 0)
   EndDo

   If oBrowse:HitBottom .Or. oBrowse:HitTop
      Tone(500,2)
   EndIf

   If oBrowse:Stable
      nKey := Inkey(0)
   EndIf

   Do Case
      Case nKey == K_UP
         oBrowse:Up()
      Case nKey == K_DOWN
         oBrowse:Down()
      Case nKey == K_LEFT
         oBrowse:Left()
      Case nKey == K_RIGHT
         oBrowse:Right()
      Case nKey == K_PGUP
         oBrowse:PageUp()
      Case nKey == K_PGDN
         oBrowse:PageDown()
      Case nKey == K_HOME
         oBrowse:Home()
      Case nKey == K_END
         oBrowse:End()
      Case nKey == K_CTRL_PGUP
         oBrowse:GoTop()
      Case nKey == K_CTRL_PGDN
         oBrowse:GoBottom()
      Case nKey == K_CTRL_LEFT
         oBrowse:PanLeft()
      Case nKey == K_CTRL_RIGHT
         oBrowse:PanRight()
      Case nKey == K_CTRL_HOME
         oBrowse:PanHome()
      Case nKey == K_CTRL_END
         oBrowse:PanEnd()
      Case nKey == K_ESC
         Exit
   EndCase
EndDo

Return

Static Function SkipArray( nMove, nLastLine, nCurrent )
Local nMoved := 0

If nMove > 0
   If nCurrent + nMove > nLastLine
      nMoved := nLastLine - nCurrent
      nCurrent := nLastLine
   Else
      nMoved := nMove
      nCurrent += nMove
   Endif
Else
   If nCurrent + nMove < 1
      nMoved := 1 - nCurrent
      nCurrent := 1
   Else
      nMoved := nMove
      nCurrent += nMove
   Endif
Endif

Return (nMoved)

PROCEDURE logon
PARAMETER sqlSERVER, sqlUSER, sqlPASSWORD
CLEAR
@  1,00 TO 23,79
@  7,08 SAY '                                  '
@  8,08 SAY '                          '
@  9,08 SAY '                      '
@ 10,08 SAY '                                     '
@ 11,08 SAY '                                     '
@ 12,08 SAY '                                     '
@ 13,08 SAY '                             '
@ 14,08 SAY '                             '
@ 15,08 SAY '                                     '
@ 16,08 SAY '                                     '
@ 17,08 SAY '                                   '
@ 18,08 SAY '                      '
@ 19,08 SAY '                            '
@ 20,08 SAY '                                '
SAVE SCREEN
@ 3,17,15,61 BOX '͸ '
@  3,33 SAY ' Server Logon '
@  5,19 SAY 'Server Name []'
@  9,19 SAY '    User ID []'
@ 11,19 SAY '   Password []'
@ 13,17 SAY 'Ĵ'
sqlSERVER = PADR(sqlSERVER, 20)
sqlUSER = PADR(sqlUSER, 20)
sqlPASSWORD = PADR(sqlPASSWORD, 20)
@  5,32 GET sqlSERVER PICTURE '@K!' VALID !""=TRIM(sqlSERVER)
@  9,32 GET sqlUSER PICTURE '@K!' VALID !""=TRIM(sqlSERVER)
@ 11,32 GET sqlPASSWORD PICTURE '@K!'
READ
IF LASTKEY()=27
   QUIT
ENDIF
sqlSERVER = TRIM(sqlSERVER)
sqlUSER = TRIM(sqlUSER)
sqlPASSWORD = TRIM(sqlPASSWORD)
RESTORE SCREEN
@ 24,0 SAY ''
RETURN

FUNCTION padr
PARAMETER string, length
RETURN SUBSTR(string+SPACE(length), 1, length)

* SQLBROW.PRG

