* SQLEDIT.PRG
* (c) Copyright 1990-1991 Brad H. Codd, All rights reserved
*
* To order CLIPSQL or for more information contact:
*    Brad H. Codd
*    Unisoft Marketing
*    P O Box 23070
*    Joubert Park, 2044
*    South Africa
*    (011) 642-4588 Work
*    (011) 623-1683 Home
*    (011) 484-2923 Fax

#include "inkey.ch"

? "Clipper 5.01 SQL Server/Sybase Table Editer, Version 1.00"
? "(c) Copyright 1990-1991 Brad H. Codd, All rights reserved"
?
? "Press any key to start..."
INKEY(0)
?
?
sqlSERVER = 'ALADDIN'
sqlUSER = 'SA'
sqlPASSWORD = ''
DO logon WITH sqlSERVER, sqlUSER, sqlPASSWORD

sqlLOGIN(sqlSERVER, sqlUSER, sqlPASSWORD)       && Login
sqlUSE("pubs")                                  && Database
Browser()
sqlLOGOUT()                                     && Logout
Cls
Return

Procedure Browser

Local aRowList
Local aColList
Local sqlCOLUMNS
Local oBrowse
Local nTop := 1
Local nLeft := 0
Local nBottom := MaxRow() - 2
Local nRight := MaxCol() - 2
Local nRow := 1
Local nKey

Cls

sqlQUERY("SELECT au_id, au_lname, au_fname FROM authors") && SQL Query
sqlRESULTS()                                    && Bind Results
aRowList := {}
DO WHILE .T.
   sqlCOLUMNS = sqlNEXTROW()                    && Fetch Next Row
   IF sqlCOLUMNS > 0
      aColList := {}
      FOR sqlCOLUMN = 1 TO sqlCOLUMNS
         AAdd(aColList, sqlNEXTCOL())           && Fetch Next Column
      NEXT
      AAdd(aRowList, aColList)
   ELSE
      EXIT
   ENDIF
ENDDO

oBrowse               := TBrowseNew( nTop, nLeft, nBottom, nRight )
oBrowse:HeadSep       := ""
oBrowse:ColSep        := "  "
oBrowse:GoTopBlock    := {|| nRow := 1}
oBrowse:GoBottomBlock := {|| nRow := Len( aRowList )}
oBrowse:SkipBlock     := {|nRowMove| SkipArray(nRowMove, Len( aRowList ), @nRow)}

oColumn       := TBColumnNew( "Author Id", {|| aRowList[nRow, 1]} )
oColumn:Width := 11
oBrowse:addColumn( oColumn )

oColumn       := TBColumnNew( "Last Name", {|| aRowList[nRow, 2]} )
oColumn:Width := 30
oBrowse:addColumn( oColumn )

oColumn       := TBColumnNew( "First Name", {|| aRowList[nRow, 3]} )
oColumn:Width := 30
oBrowse:addColumn( oColumn )

SetColor("N/W")
@ nBottom+1, nLeft Say Replicate(" ", nRight-nLeft+1)
@ nBottom+1, nLeft Say "<> Edit, <Ins> Add, <Del> Delete, <Esc> Exit"
SetColor("W/N")

Do While .T.

   Do While !(oBrowse:Stabilize()) .And. ((nKey := Inkey()) == 0)
   EndDo

   If oBrowse:HitBottom .Or. oBrowse:HitTop
      ?? Chr(7)
   EndIf

   If oBrowse:Stable
      nKey := Inkey(0)
   EndIf

   Do Case
      Case nKey == K_UP
         oBrowse:Up()
      Case nKey == K_DOWN
         oBrowse:Down()
      Case nKey == K_LEFT
         oBrowse:Left()
      Case nKey == K_RIGHT
         oBrowse:Right()
      Case nKey == K_PGUP
         oBrowse:PageUp()
      Case nKey == K_PGDN
         oBrowse:PageDown()
      Case nKey == K_HOME
         oBrowse:Home()
      Case nKey == K_END
         oBrowse:End()
      Case nKey == K_CTRL_PGUP
         oBrowse:GoTop()
      Case nKey == K_CTRL_PGDN
         oBrowse:GoBottom()
      Case nKey == K_CTRL_LEFT
         oBrowse:PanLeft()
      Case nKey == K_CTRL_RIGHT
         oBrowse:PanRight()
      Case nKey == K_CTRL_HOME
         oBrowse:PanHome()
      Case nKey == K_CTRL_END
         oBrowse:PanEnd()
      Case nKey == K_ESC
         Exit
      Case nKey == K_INS
         Inserter(aRowList, nRow)
         oBrowse:RefreshAll()
      Case nKey == K_ENTER
         Editer(aRowList, nRow)
         oBrowse:RefreshCurrent()
      Case nKey == K_DEL
         Deleter(aRowList, nRow)
         oBrowse:RefreshAll()
   EndCase
EndDo

Return

Static Function SkipArray( nMove, nLastLine, nCurrent )
Local nMoved := 0

If nMove > 0
   If nCurrent + nMove > nLastLine
      nMoved := nLastLine - nCurrent
      nCurrent := nLastLine
   Else
      nMoved := nMove
      nCurrent += nMove
   Endif
Else
   If nCurrent + nMove < 1
      nMoved := 1 - nCurrent
      nCurrent := 1
   Else
      nMoved := nMove
      nCurrent += nMove
   Endif
Endif

Return (nMoved)

Procedure Inserter(aRowList, nRow)
Local sqlCOLUMNS
Local au_id, au_lname, au_fname, phone, address, city, state, zip, contract
Local nTop, nLeft, nBottom, nRight
Local lUnique
Local nError
Set Confirm On
nTop := MaxRow()-11
nLeft := MaxCol()-79
nBottom := MaxRow()
nRight := MaxCol()
Save Screen
@ nTop, nLeft, nBottom, nRight Box "͸ "
@ nTop+1, nLeft+1 Say PadL("Author Id", 25)
@ nTop+2, nLeft Say ""+Replicate("",nRight-nLeft-1)+""
@ nTop+3, nLeft+1 Say PadL("Last Name", 25)
@ nTop+4, nLeft+1 Say PadL("First Name", 25)
@ nTop+5, nLeft+1 Say PadL("Phone", 25)
@ nTop+6, nLeft+1 Say PadL("Address", 25)
@ nTop+7, nLeft+1 Say PadL("City", 25)
@ nTop+8, nLeft+1 Say PadL("State", 25)
@ nTop+9, nLeft+1 Say PadL("Zip", 25)
@ nTop+10, nLeft+1 Say PadL("Contract", 25)
au_id := Space(11)
au_lname := Space(40)
au_fname := Space(40)
phone := Space(12)
address := Space(40)
city := Space(20)
state := Space(2)
zip := Space(5)
contract := Space(1)
Do While .T.
   @ nTop+1,nLeft+27 Get au_id Picture "999-99-9999"
   SetColor("N/W")
   @ nTop+3,nLeft+27 Say au_lname
   @ nTop+4,nLeft+27 Say au_fname
   @ nTop+5,nLeft+27 Say phone
   @ nTop+6,nLeft+27 Say address
   @ nTop+7,nLeft+27 Say city
   @ nTop+8,nLeft+27 Say state
   @ nTop+9,nLeft+27 Say zip
   @ nTop+10,nLeft+27 Say contract
   SetColor("W/N")
   Read
   If LastKey()=27
      Restore Screen
      Return
   Endif
   sqlQUERY('SELECT au_id FROM authors WHERE au_id="'+au_id+'"')   && SQL Query
   sqlRESULTS()                                    && Bind Results
   lUnique := .T.
   DO WHILE .T.
      sqlCOLUMNS = sqlNEXTROW()                    && Fetch Next Row
      IF sqlCOLUMNS > 0
         lUnique := .F.
      ELSE
         EXIT
      ENDIF
   ENDDO
   If lUnique
      Exit
   Endif
   ?? Chr(7)
Enddo
@ nTop+3,nLeft+27 Get au_lname
@ nTop+4,nLeft+27 Get au_fname
@ nTop+5,nLeft+27 Get phone
@ nTop+6,nLeft+27 Get address
@ nTop+7,nLeft+27 Get city
@ nTop+8,nLeft+27 Get state
@ nTop+9,nLeft+27 Get zip
@ nTop+10,nLeft+27 Get contract
Read
If !LastKey()=27
   If !sqlQUERY('INSERT INTO authors(au_id, au_lname, au_fname, phone, address, city, state, zip, contract) VALUES ("'+au_id+'", "'+au_lname+'", "'+au_fname+'", "'+phone+'", "'+address+'", "'+city+'", "'+state+'", "'+zip+'", '+contract+')')=1
      Cls
      ? LTrim(Str(sqlERROR()))+" Error(s)"
      ?
      For nError = 1 To sqlERROR()
         ? sqlNEXTERR()
         Wait
         ?
      Next
   Else
      If !sqlRESULTS()=1
         Cls
         ? LTrim(Str(sqlERROR()))+" Error(s)"
         ?
         For nError = 1 To sqlERROR()
            ? sqlNEXTERR()
            Wait
            ?
         Next
      Else
         AAdd(aRowList, {au_id, au_lname, au_fname} )
      Endif
   Endif
Endif
Restore Screen
Return

Procedure Editer(aRowList, nRow)
Local sqlCOLUMNS
Local au_id, au_lname, au_fname, phone, address, city, state, zip, contract
Local nTop, nLeft, nBottom, nRight
Local nError
Set Confirm On
sqlQUERY('SELECT au_id, au_lname, au_fname, phone, address, city, state, zip, contract FROM authors WHERE au_id="'+aRowList[nRow, 1]+'"')   && SQL Query
sqlRESULTS()                                    && Bind Results
DO WHILE .T.
   sqlCOLUMNS = sqlNEXTROW()                    && Fetch Next Row
   IF sqlCOLUMNS > 0
      au_id := PadR(sqlNEXTCOL(), 11)           && Fetch Columns
      au_lname := PadR(sqlNEXTCOL(), 40)
      au_fname := PadR(sqlNEXTCOL(), 20)
      phone := PadR(sqlNEXTCOL(), 12)
      address := PadR(sqlNEXTCOL(), 40)
      city := PadR(sqlNEXTCOL(), 20)
      state := PadR(sqlNEXTCOL(), 2)
      zip := PadR(sqlNEXTCOL(), 5)
      contract := PadR(sqlNEXTCOL(), 1)
   ELSE
      EXIT
   ENDIF
ENDDO
nTop := MaxRow()-11
nLeft := MaxCol()-79
nBottom := MaxRow()
nRight := MaxCol()
Save Screen
@ nTop, nLeft, nBottom, nRight Box "͸ "
@ nTop+1, nLeft+1 Say PadL("Author Id", 25)
@ nTop+2, nLeft Say ""+Replicate("",nRight-nLeft-1)+""
@ nTop+3, nLeft+1 Say PadL("Last Name", 25)
@ nTop+4, nLeft+1 Say PadL("First Name", 25)
@ nTop+5, nLeft+1 Say PadL("Phone", 25)
@ nTop+6, nLeft+1 Say PadL("Address", 25)
@ nTop+7, nLeft+1 Say PadL("City", 25)
@ nTop+8, nLeft+1 Say PadL("State", 25)
@ nTop+9, nLeft+1 Say PadL("Zip", 25)
@ nTop+10, nLeft+1 Say PadL("Contract", 25)
SetColor("N/W")
@ nTop+1,nLeft+27 Say au_id
SetColor("W/N")
@ nTop+3,nLeft+27 Get au_lname
@ nTop+4,nLeft+27 Get au_fname
@ nTop+5,nLeft+27 Get phone
@ nTop+6,nLeft+27 Get address
@ nTop+7,nLeft+27 Get city
@ nTop+8,nLeft+27 Get state
@ nTop+9,nLeft+27 Get zip
@ nTop+10,nLeft+27 Get contract
Read
If !LastKey()=27
   If !sqlQUERY('UPDATE authors SET au_lname = "'+au_lname+'", au_fname = "'+au_fname+'", phone = "'+phone+'", address = "'+address+'", city = "'+city+'", state = "'+state+'", zip = "'+zip+'", contract = '+contract+' WHERE au_id="'+aRowList[nRow, 1]+'"')=1
      Cls
      ? LTrim(Str(sqlERROR()))+" Error(s)"
      ?
      For nError = 1 To sqlERROR()
         ? sqlNEXTERR()
         Wait
         ?
      Next
   Else
      If !sqlRESULTS()=1
         Cls
         ? LTrim(Str(sqlERROR()))+" Error(s)"
         ?
         For nError = 1 To sqlERROR()
            ? sqlNEXTERR()
            Wait
            ?
         Next
      Else
         aRowList[nRow] := {au_id, au_lname, au_fname}
      Endif
   Endif
Endif
Restore Screen
Return

Procedure Deleter(aRowList, nRow)
If Alert("Delete this Author now?", {"YES", "NO "})=1
   sqlQUERY('DELETE FROM authors WHERE au_id="'+aRowList[nRow, 1]+'"')
   sqlRESULTS()
   ADEL(aRowList, nRow)
   ASIZE(aRowList, LEN(aRowList)-1)
Endif
Return

PROCEDURE logon
PARAMETER sqlSERVER, sqlUSER, sqlPASSWORD
CLEAR
@  1,00 TO 23,79
@  7,08 SAY '                                  '
@  8,08 SAY '                          '
@  9,08 SAY '                      '
@ 10,08 SAY '                                     '
@ 11,08 SAY '                                     '
@ 12,08 SAY '                                     '
@ 13,08 SAY '                             '
@ 14,08 SAY '                             '
@ 15,08 SAY '                                     '
@ 16,08 SAY '                                     '
@ 17,08 SAY '                                   '
@ 18,08 SAY '                      '
@ 19,08 SAY '                            '
@ 20,08 SAY '                                '
SAVE SCREEN
@ 3,17,15,61 BOX '͸ '
@  3,33 SAY ' Server Logon '
@  5,19 SAY 'Server Name []'
@  9,19 SAY '    User ID []'
@ 11,19 SAY '   Password []'
@ 13,17 SAY 'Ĵ'
sqlSERVER = PADR(sqlSERVER, 20)
sqlUSER = PADR(sqlUSER, 20)
sqlPASSWORD = PADR(sqlPASSWORD, 20)
@  5,32 GET sqlSERVER PICTURE '@K!' VALID !""=TRIM(sqlSERVER)
@  9,32 GET sqlUSER PICTURE '@K!' VALID !""=TRIM(sqlSERVER)
@ 11,32 GET sqlPASSWORD PICTURE '@K!'
READ
IF LASTKEY()=27
   QUIT
ENDIF
sqlSERVER = TRIM(sqlSERVER)
sqlUSER = TRIM(sqlUSER)
sqlPASSWORD = TRIM(sqlPASSWORD)
RESTORE SCREEN
@ 24,0 SAY ''
RETURN

FUNCTION padr
PARAMETER string, length
RETURN SUBSTR(string+SPACE(length), 1, length)

* SQLEDIT.PRG

